import { CancelledError, TimeoutError } from './error';
import { assign } from './tools';
export const cancellable = (promise, abort, timeout) => {
    let cancel;
    const cancelable = new Promise((_, reject) => {
        let timeoutId;
        const rejectWith = Cls => arg => {
            clearTimeout(timeoutId);
            reject(new Cls(arg));
            abort && abort();
        };
        cancel = rejectWith(CancelledError);
        if (typeof timeout === 'number') {
            timeoutId = setTimeout(rejectWith(TimeoutError), timeout, timeout);
        }
    });
    return assign(Promise.race([promise, cancelable]), { cancel });
};
export const defer = () => {
    const deferred = {};
    deferred.req = new Promise((resolve, reject) => {
        deferred.rs = resolve;
        deferred.rj = reject;
    });
    deferred.req.catch(() => { });
    return deferred;
};
